/*
 * NondeterministicExactFactorAutomaton.cpp
 *
 *  Created on: 7. 4. 2015
 *      Author: Jan Travnicek
 */

#include "NondeterministicExactFactorAutomaton.h"
#include <string/LinearString.h>
#include <string/Epsilon.h>

#include <deque>

namespace stringology {

namespace indexing {

automaton::Automaton NondeterministicExactFactorAutomaton::construct(const string::String& text) {
	return dispatch(text.getData());
}

auto ExactFactorAutomatonLinearString = NondeterministicExactFactorAutomaton::RegistratorWrapper<automaton::EpsilonNFA < DefaultSymbolType, DefaultEpsilonType, unsigned >, string::LinearString < > >(NondeterministicExactFactorAutomaton::construct);

} /* namespace indexing */

} /* namespace stringology */
